PrintWriter txtdatoteka;
PMatrix matrica;
int i;

void draw() {
  point(mouseX, mouseY);
}

void setup() {
  size (640,480);
  txtdatoteka = createWriter("izlaz/matrice.txt");   // Kreira novu txt datoteku u  mapi "izlaz"
  i=0;
  stroke(0);
  fill(0);
  textSize(22);
  text("Tipke + i - za sljedeću i prethodnu transformaciju",30,80);
  text("Tipka . za kraj",30,180);
}

void crtaj(int i) {
  background(128);
  // printMatrix();
  stroke(255,127,127);line(-1000,0,1000,0);
  stroke(255,0,0);line(-1000,200,1000,200);
  
  stroke(127,127,255);line(0,-1000,0,1000);
  stroke(0,0,255);line(200,-1000,200,1000);
  stroke(0);
  
  rect(10,10,45,30);
  textSize(32);
  text("Dobar dan",100,50);
  saveFrame("izlaz/slika" + i + ".png");
  txtdatoteka.println("Matrica " + i +": ");
  ispisiTransformacijskuMatricuUDatoteku(txtdatoteka);
  println("Matrica " + i + ":");
  printMatrix();
  resetMatrix();
}


void ispisiTransformacijskuMatricuUDatoteku(PrintWriter pw) {
  float[] polje6 = new float[6];
  int i,j, indeks;
  matrica = getMatrix();
  matrica.get(polje6);
  for (i=0;i<=1;++i) {
    for (j=0;j<=2;++j) {
      indeks = 3*i+j;
      pw.print(indeks + ": " + polje6[3*i+j] + "    ");
    }
    pw.println();
  }
}


void keyTyped() {
  if (key == '+') {
    ++i; if (i==14) i=1;
  } else {
    --i; if (i==0) i=11;
  }
  if (key == '.') {
      txtdatoteka.flush(); // Ispisujemo preostali tekst u datoteku i ...
      txtdatoteka.close();      // ... zatvaramo datoteku
      exit();  
  }
  
  switch(i) {
    case 1: 
      crtaj(1); break;
    case 2: 
      scale(2); crtaj(2); break;
    case 3: 
      rotate(PI/6); crtaj(3);  break;
    case 4: 
      translate(100,0); crtaj(4); break;
    case 5: 
      translate(0,50); crtaj(5); break;
    case 6: 
      translate(80,40); crtaj(6);  break;
    case 7: 
      shearX(PI/6); crtaj(7); break;
    case 8: 
      shearY(PI/6); crtaj(8); break;
    case 9: 
      applyMatrix(1,0,0,1,-1,100); crtaj(9); break;
    case 10: 
      translate(125,0); crtaj(10); break;
    case 11: 
      scale(-1.5); 
      translate(-220,-220); crtaj(11); break;
    case 12: 
      scale(-1); 
      translate(120,120); crtaj(12); break;
    case 13: 
      applyMatrix(-1,0,400,0,1,100); crtaj(13); break;
    }
}
